Module org.jfree.chart3d
Package org.jfree.chart3d

# Class Chart3DPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
org.jfree.chart3d.graphics3d.swing.Panel3D
org.jfree.chart3d.Chart3DPanel

All Implemented Interfaces:
  `ComponentListener`, `MouseListener`, `MouseMotionListener`, `MouseWheelListener`, `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `Chart3DChangeListener`

public class Chart3DPanel extends Panel3D implements Chart3DChangeListener, ComponentListener
A panel designed to display a `Chart3D` in a Swing-based desktop application. The panel registers with the chart to receive change notifications, and when these are received the chart is automatically repainted.
This panel will display the chart, but does not include additional features such as the view toolbar and popup menu (these are provided by the `DisplayPanel3D` class).
NOTE: This class is serializable, but the serialization format is subject to change in future releases and should not be relied upon for persisting instances of this class.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JPanel

`JPanel.AccessibleJPanel`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`Chart3DPanel(Chart3D chart)`
Creates a new chart panel to display the specified chart.

## Method Summary

Modifier and Type
Method
Description
`void`
`addChartMouseListener(Chart3DMouseListener listener)`
Adds a listener to the list of objects listening for chart mouse events.
`void`
`chartChanged(Chart3DChangeEvent event)`
Receives notification when the chart has been modified, and responds by completely repainting the panel and chart.
`void`
`componentHidden(ComponentEvent e)`
`void`
`componentMoved(ComponentEvent e)`
`void`
`componentResized(ComponentEvent e)`
`void`
`componentShown(ComponentEvent e)`
`Chart3D`
`getChart()`
Returns the chart being displayed in this panel.
`<T extends EventListener>
T[]`
`getListeners(Class<T> listenerType)`
Returns an array of the listeners of the given type registered with the panel.
`String`
`getToolTipText(MouseEvent e)`
`void`
`mouseClicked(MouseEvent e)`
Receives a mouse event and passes it on to registered `Chart3DMouseListener`s along with the underlying rendered element if any.
`void`
`mouseMoved(MouseEvent e)`
Receives a mouse event and passes it on to registered `Chart3DMouseListener`s along with the underlying rendered element if any.
`void`
`removeChartMouseListener(Chart3DMouseListener listener)`
Removes a listener from the list of objects listening for chart mouse events.

### Methods inherited from class org.jfree.chart3d.graphics3d.swing.Panel3D

`getDrawable, getLastClickPoint, getMargin, getMaxViewingDistanceMultiplier, getMinViewingDistance, getPanIncrement, getRenderingInfo, getRollIncrement, getRotateIncrement, getViewPoint, mouseDragged, mouseEntered, mouseExited, mousePressed, mouseReleased, mouseWheelMoved, paintComponent, panLeftRight, registerForTooltips, setMargin, setMaxViewingDistanceMultiplier, setPanIncrement, setRollIncrement, setRotateIncrement, setViewPoint, unregisterForTooltips, zoomToFit, zoomToFit`

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Chart3DPanel

public Chart3DPanel(Chart3D chart)
Creates a new chart panel to display the specified chart.

Parameters:
  `chart` - the chart.

## Method Details

### getChart

public Chart3D getChart()
Returns the chart being displayed in this panel.

Returns:
  The chart (never `null`).
Since:
  1.3

### chartChanged

public void chartChanged(Chart3DChangeEvent event)
Receives notification when the chart has been modified, and responds by completely repainting the panel and chart.

Specified by:
  `chartChanged` in interface `Chart3DChangeListener`
Parameters:
  `event` - the event.

### componentResized

public void componentResized(ComponentEvent e)

Specified by:
  `componentResized` in interface `ComponentListener`

### componentMoved

public void componentMoved(ComponentEvent e)

Specified by:
  `componentMoved` in interface `ComponentListener`

### componentShown

public void componentShown(ComponentEvent e)

Specified by:
  `componentShown` in interface `ComponentListener`

### componentHidden

public void componentHidden(ComponentEvent e)

Specified by:
  `componentHidden` in interface `ComponentListener`

### getToolTipText

public String getToolTipText(MouseEvent e)

Overrides:
  `getToolTipText` in class `JComponent`

### mouseClicked

public void mouseClicked(MouseEvent e)
Receives a mouse event and passes it on to registered `Chart3DMouseListener`s along with the underlying rendered element if any.

Specified by:
  `mouseClicked` in interface `MouseListener`
Overrides:
  `mouseClicked` in class `Panel3D`
Parameters:
  `e` - the mouse event.

### mouseMoved

public void mouseMoved(MouseEvent e)
Receives a mouse event and passes it on to registered `Chart3DMouseListener`s along with the underlying rendered element if any.

Specified by:
  `mouseMoved` in interface `MouseMotionListener`
Overrides:
  `mouseMoved` in class `Panel3D`
Parameters:
  `e` - the mouse event.

### addChartMouseListener

public void addChartMouseListener(Chart3DMouseListener listener)
Adds a listener to the list of objects listening for chart mouse events.

Parameters:
  `listener` - the listener (`null` not permitted).
Since:
  1.3

### removeChartMouseListener

public void removeChartMouseListener(Chart3DMouseListener listener)
Removes a listener from the list of objects listening for chart mouse events.

Parameters:
  `listener` - the listener (`null` not permitted).
Since:
  1.3

### getListeners

public <T extends EventListener> T[] getListeners(Class<T> listenerType)
Returns an array of the listeners of the given type registered with the panel.

Overrides:
  `getListeners` in class `JComponent`
Parameters:
  `listenerType` - the listener type.
Returns:
  An array of listeners.